<script setup>
import MyBooks from '../components/ListeBook.vue'
import BookItem from '../components/BookItem.vue'

import { ref, onMounted } from 'vue'

const data = ref(null)
const error = ref(null)

async function ajouter_book(e){
  e.cancelBubble = true;
  let book = e.target;
  while(!book.classList.contains('elm_list_book')){
    book = book.parentElement;
  }
  fetch ('https://api.mangaUpdate.fr/api/addBook', {
    method: 'POST',
    headers: {'Content-Type' : 'application/json'},
    body: JSON.stringify({
      'id':book.getAttribute('data_book'),
      'token':sessionStorage.getItem('authentificated')
    })
  }).then((res) => res.json())
    .then(() => location.reload())
    .catch((err) => (error.value = err))
}

fetch ('https://api.mangaUpdate.fr/api/otherBooks', {
  method: 'POST',
  headers: {'Content-Type' : 'application/json'},
  body: JSON.stringify({
    'token':sessionStorage.getItem('authentificated')
  })
}).then((res) => res.json())
  .then((json) => (data.value = json))
  .catch((err) => (error.value = err))

onMounted(() => {
  document.getElementById('search_book').firstElementChild.addEventListener('keyup', async function(){
    fetch ('https://api.mangaUpdate.fr/api/findBooks', {
      method: 'POST',
      headers: {'Content-Type' : 'application/json'},
      body: JSON.stringify({
        'name':document.getElementById('search_book').firstElementChild.value,
        'token':sessionStorage.getItem('authentificated')
      })
    }).then((res) => res.json())
      .then((json) => (data.value = json))
      .catch((err) => (error.value= err))
  })
})
</script>

<template>
  <main class="container mx-auto flex flex-col items-center pt-8 z-10">
    <MyBooks />
    <label class='flex justify-center my-4 mx-auto p-2 bg-gray-300' id="add_book" for="ajouter_book">
      <font-awesome-icon class='h-10 text-gray-600' icon="fa-solid fa-plus"/>
    </label>
  </main>
  <input type="checkbox" id="ajouter_book" class='hidden peer/overlay'/>
  <div id="overlay_ajouter_book" class="group flex flex-col peer-checked/overlay:z-20 peer-checked/overlay:opacity-100 peer-checked/overlay:h-screen h-0 w-full absolute top-0 left-0 opacity-0 z-0 transition-75">
    <div id="overlay" class="bg-black opacity-70 absolute top-0 left-0 h-full w-full"></div>
    <label class='flex my-20 mx-auto justify-center p-4 bg-gray-300 rounded-full w-24' id="fermer_overlay_book" for="ajouter_book">
      <font-awesome-icon icon="fa-solid fa-xmark" class="h-16 text-red-600"/>
    </label>
    <div id="menu_ajout_book" class="bg-zinc-600 py-8 px-12 h-full flex flex-col items-center">
        
      <form id="search_book" action="javascript:void(0);">
        <input type="text" placeholder="Recherche" class="rounded-xl py-1 px-8 mb-4 bg-zinc-300 w-full text-black text-center">
      </form>
      <div v-if="error" class="error">{{ error }}</div>
      <div v-else-if="data" class="content self-stretch lg:grid lg:gap-2 lg:grid-cols-2 xl:grid-cols-3 2xl:grid-cold-4">
        <li class='list-none elm_list_book' v-for="book in data" @click="ajouter_book" v-bind:data_book="book.id">
          <BookItem>
            <template #image>
              <img v-bind:src="book.image.replace('asura.gg', 'asura.nacm.xyz')" alt="image du livre" class="w-1/5 me-3">
            </template>
            <template #name>
              <h2>
                {{ book.name }}
              </h2>
            </template>
          </BookItem>
        </li>
      </div>
      <div v-else="loading" class="loading">Loading...</div>
    </div>
  </div>
  <input type="checkbox" id="voir_websites" class='hidden peer/overlay_websites'/>
  <div id="overlay_voir_websites" class="group flex flex-col peer-checked/overlay_websites:z-20 peer-checked/overlay_websites:opacity-100 peer-checked/overlay_websites:h-screen h-0 w-full absolute top-0 left-0 opacity-0 z-0 transition-75 overflow-y-scroll">
    <div id="overlay_websites" class="bg-black opacity-70 absolute top-0 left-0 h-full w-full"></div>
    <div id="menu_voir_websites" class="bg-zinc-600 mt-32 px-4">
      <label class='flex my-2 ms-auto justify-center p-1 bg-gray-300 rounded-full w-10 sticky top-8 z-10' id="fermer_overlay_voir_websites" for="voir_websites">
        <font-awesome-icon icon="fa-solid fa-xmark" class="h-8 text-red-600"/>
      </label>
      <div class="loading">Loading...</div>
    </div>
  </div>
</template>

<style>

@tailwind base;
@tailwind components;
@tailwind utilities;

.content{
  overflow-x: hidden;
}

</style>